package hellojpa;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.*;

public class JPAManager {
	private EntityManagerFactory factory;
	
	public JPAManager(){
		factory = Persistence.createEntityManagerFactory("hellojpa");
	}
	
	public void addGrade(Grade grade){
		EntityManager em = factory.createEntityManager();
		em.getTransaction().begin();
		
		em.persist(grade);
		
		em.getTransaction().commit();
		em.close();
	}
	
	public void showGrades(){
		EntityManager em = factory.createEntityManager();
		Query q = em.createQuery("select g from Grade g");
		List<Grade> grades = new ArrayList<Grade>();
		grades = (List<Grade>) q.getResultList();
		for (Grade g : grades) {
            System.out.println("Grade:"+g.getName()); 
            for(Student s:g.getStudents()){
            	System.out.println(s.getId());
            }
        }	
		em.close();
	}
	
	public void showStudents(){
		EntityManager em = factory.createEntityManager();
		Query q = em.createQuery("select s from Student s");
		List<Student> students = new ArrayList<Student>();
		students = (List<Student>) q.getResultList();
		for (Student s : students) {
            System.out.println(" Studs:"+s.getId()+" grade: "+s.getMyGrade().getName()+" ("+s.getMyGrade().getId()+")"); 
        }	
		em.close();
	}
	
}
